%tau is how fast to decay back to 0
function [k1 t, vid, vid_k]= cov_descend_online(N, sigma, p, r, nsteps, temp,tau)
    M = numel(p);
    bw = 30*sqrt(2);

    s = get_s(N,M, bw); 
    s_big = get_s(N,N,bw);
    

    k1 = ones(N);
    errs = [];
    t_orig = get_t(s, ones(N), sigma);
    
    
    c_orig = get_cov(t_orig, ones(1,M)/M);
    
    steps = 0;
    generator = get_ori_generator(1:M, p);
    acc = 0;
    vid = zeros([N N nsteps]);
    vid_k = zeros([N, N, nsteps]);
    

    orist = linspace(-90, 90, N+1);
    orist = orist(1:N);
    orist = orist - orist(ceil(N/2)); %blagh


    %sanity check
    function exp_prod = est_exp_prod(tt, gg)
        exp_prod = 0;
        for iter=1:1000
            ori_ind = gg();
            tc = tt(:, ori_ind);
            exp_prod = exp_prod + tc * tc'; 
       end
    end

    while steps < nsteps

        steps = steps + 1;
        t = get_t(s, k1, sigma);

        
        ori_ind = generator();
        tune_curve = t(:,ori_ind)'; %misleading, pop resp not tune curve
        
        deltaXY = tune_curve'*tune_curve - c_orig;
        
        acc = 0.9*acc + 0.1*deltaXY;
        
        
        t = get_t(s, k1, sigma);
        tb = get_t(s_big, k1, sigma);

        vid(:,:,steps) = tb;
        vid_k(:,:,steps) = k1;
        c = get_joint(t, p);

        k1 = max(0, k1 + 5*temp*(acc - c_orig)); %make it batch
        
        if true
            
            subplot(2,2,1)
            imagesc(k1)
            title('norm matrix')

            subplot(2,2,2)
            imagesc(c)
            title('population E(joint-product)')

            subplot(2,2,3)
            plot(orist, get_mean(tb, orist, 1),'k')           
            title('tuning-curve shift')
            subplot(2,2,4)
            imagesc(tb)
            title('tuning-curve matrix')
            drawnow
        end

       
    end
    c = get_cov(t, p);
    t = get_t(s, k1, sigma);
end
