%returns a probability distribution over orientations which is biased with
%a gaussian lump at 0
function pb = get_gauss_bias(M, pb_bw, pb_g)
    pbw = -0.5*(pb_bw/360*2*pi)^2 / log(0.5);
    lump = exp(-linspace(-pi, pi, M).^2/pbw);
    lump = pb_g * lump / sum(lump);
    pb = 1/M + lump;
    pb = pb / sum(pb);
end