%returns the optimal (as in deep's work) tuning curves associated with
%probability distribution pb
function [s, oris, oris_n] = get_s(N, M, ori_bw, pb)
    
    pb_cum = cumsum(pb);

    oris = [0 pb_cum(1:(end-1))] * pi;
    center = ceil(M/2);
    ori_center = oris(center);
    oris = oris - ori_center + pi/2;
    
    oris_n_extra = linspace(0, pi, N+1);
    oris_n = oris_n_extra(1:N);
    center = ceil(N/2);
    ori_center = oris_n(center);
    oris_n = oris_n - ori_center + pi/2;

    %ori_bw = 30;
    population_fun = get_population(oris_n, (ori_bw/360)*2*pi);
    s = zeros(numel(oris_n), numel(oris));
    for i=1:numel(oris)
        p_i = population_fun(oris(i))';
        s(:,i) = p_i;
    end
end