function [pf1, pf2] = get_population_2layer(oris, half_height, intrp)

	%e^-((half_height^2)/(2*v)) = 0.5
	%log(0.5)*2*v = -half_height ^ 2
	v = -0.5*half_height^2 / log(0.5);	
	%v = -0.5*half_height^2 / log(sqrt(2)/2);	
	intrp = intrp ^ 2;
    function resp = population_response1(ori)
		%orientations are mod 180
		%we need to compute the difference in orientation		
		ori_d = min(abs(oris - ori), pi - abs(oris - ori));
		resp = exp(-1*(ori_d.^2)/(2*intrp*v));
        
    end
    function resp = population_response2(ori)
		%orientations are mod 180
		%we need to compute the difference in orientation		
		ori_d = min(abs(oris - ori), pi - abs(oris - ori));
		resp = exp(-1*(ori_d.^2)/(2*(1-intrp)*v));
        
	end
	pf1 = @population_response1;
    pf2 = @population_response2;
end