function [s, oris, oris_n] = get_s(N, varargin)
    if numel(varargin) > 0
        M = varargin{1};
    else
        M = N;
    end
    %M is the number of neurons
    if numel(varargin) > 1
        ori_bw = varargin{2};
    else
        ori_bw = 30;
    end
    
    if numel(varargin) > 2
        contrast = varargin{3};
    else
        contrast = 1.0;
    end
    %NOTE changing 4/3/14 to always make the center stimulus orientation 90
    %degrees. If even, then round down.
    %this is so it shows up in the center!
    oris_extra = linspace(0,pi,M+1);
    oris = oris_extra(1:M);
    center = ceil(M/2);
    ori_center = oris(center);
    oris = oris - ori_center + pi/2;
    
    oris_n_extra = linspace(0, pi, N+1);
    oris_n = oris_n_extra(1:N);
    center = ceil(N/2);
    ori_center = oris_n(center);
    oris_n = oris_n - ori_center + pi/2;

    %ori_bw = 30;
    population_fun = get_population(oris_n, (ori_bw/360)*2*pi);
    s = zeros(numel(oris_n), numel(oris));
    for i=1:numel(oris)
        p_i = population_fun(oris(i))';
        s(:,i) = p_i;
    end
    s = contrast*s;
end
