%this model implements gain changes in the individual neurons to achieve
%homeostasis, and includes normalization.
function [w t tb] = one_layer_norm_model(N, sigma, p, temp)

    p_unbiased = ones(size(p)) / numel(p);
    M = numel(p);
    bw = 30*sqrt(2);
    contrast = get_contrast();
    
    s = get_s(N,M, bw, contrast); 
    wscale = mean(get_s(N, 1, 30*sqrt(2)).^2);
    k1 = ones(N)/wscale;
    t_init = get_t(s, k1, sigma);
    w = ones(1,N);
    
    %firing rate target
    C = t_init * p_unbiased';
    for step = 1:10000
        s_adp = diag(w) * s;
        t = get_t(s_adp, k1, sigma);
        
        %compute differences in firing rates
        delta_firing = t * p' - C;
        w = w - temp * delta_firing';
       
    end
    tb = get_t(diag(w) * get_s(N,N,bw, contrast), k1, sigma);

end
