function [w1, w2, t, tb]= weight_descend_2layer(N, sigma, p, intrp, temps)
    
    contrast = get_contrast();
    [s1 s2] = get_s_2layer(N, intrp, numel(p));
    s1 = s1*contrast;
    s2 = s2*contrast;
    k = ones(N);
    steps = 0;
    
    w1 = ones(1, N)';
    w2 = ones(1, N)';
    s_now = diag(w1)*s1;
    t_now = diag(w2)*get_t_2layer(s_now , s2, k, sigma);

    layer1_mean_init = s_now * ones(size(p'))/numel(p);
    layer2_mean_init = t_now * ones(size(p'))/numel(p);
    while steps < 5000
        
        steps = steps + 1;
        s_now = diag(w1)*s1;
        t_now = diag(w2)*get_t_2layer(s_now , s2, k, sigma);
        layer1_mean = s_now * p';
        layer2_mean = t_now * p';
        w1 = w1 - (layer1_mean - layer1_mean_init)*temps(1);
       
        w2 = w2 - (layer2_mean - layer2_mean_init)*temps(2);
        
    end
    t = t_now;

    [s1 s2] = get_s_2layer(N, intrp, N);
    s_now = diag(w1)*s1;
    tb = diag(w2)*get_t_2layer(s_now , s2, k, sigma);

end
