%equal spacing in percentiles
function [xm, yv] = measureCondVar(x, y,  N)
    bintops = [];
    for bin=1:N
        pct = bin/N;
        bintops = [bintops, percentile(x, pct)];
    end
    
    bintops = [0, bintops];
    
    xm = [];
    yv = [];
    for bin=2:(N+1)
        inds = (x >= bintops(bin-1)) & (x < bintops(bin));
        
        sely = y(inds);
        selx = x(inds);
        xm = [xm, mean(selx)];
        yv = [yv, var(sely)];
    end
end

function px = percentile(x, p)
    x = sort(x);
    pind = ceil(p * numel(x));
    px = x(pind);
end