clear all

s = get_s(17,360,15);
s2 = get_s(360,360,15);
sv = 0.2;
sa = 0.2;
sm = 0.4;
suppression = @(ori) exp(-1 * (ori - 0).^2/(2*sv^2));
sup_n = suppression(linspace(-1, 1, size(s,1)));
sup_n2 = suppression(linspace(-1, 1, size(s2,2)));

ns = diag(sup_n) * s;
ns2 = diag(sup_n2) * s2;

adapt = @(ori) 1-sm*exp(-1 * (ori + 0.2).^2/(2*sa^2));
nsa = diag(adapt(linspace(-1, 1, size(s, 1)))) * ns;
ns2a = diag(adapt(linspace(-1, 1, size(s2, 1)))) * ns2;

supr = adapt(linspace(-1, 1, 100));


fs = 12;
lw = 2;
subplot(2,2,1)
h=plot(linspace(-90, 90, size(s,2)), ns','k');
set(h, 'LineWidth',lw);
hold on
h=plot(linspace(-90, 90, size(s,2)), ns(8,:)','r');
set(h, 'Color',[0.85,0.0,0.0])
set(h, 'LineWidth',lw);
set(gca, 'XTick',[-90, -45, 0, 45, 90])
set(gca, 'YTick',[0.0, 0.5, 1])

h=title('A');


set(h, 'FontSize', 20)

h=ylabel('Neural response');
set(h, 'FontSize',fs)
set(gca, 'FontSize',fs);
axis([-91, 91, 0, 1.05])


subplot(2,2,2)
h=plot(linspace(-90, 90, size(s2,2)), sum(ns2, 1)/max(sum(ns2,1)), 'k');
hold on
set(h, 'LineWidth',lw);
h=plot([0, 0],[ 0, 1],'k--');
set(h, 'LineWidth',lw);


set(gca, 'FontSize',fs);
axis([-91, 91, 0, 1.05])
set(gca, 'XTick',[-90, -45, 0, 45, 90])
set(gca, 'YTick',[0.0, 0.5, 1])
h=title('B');
set(h, 'FontSize', 20)

subplot(2,2,3)
h=plot(linspace(-90, 90, size(s,2)), nsa','k');
set(h, 'LineWidth',lw);
hold on
h=plot(linspace(-90, 90, size(s,2)), nsa(8,:)','r');
set(h, 'LineWidth',lw);
set(h, 'Color',[0.85,0.0,0.0])


h=xlabel('Stimulus orientation');
set(h, 'FontSize',fs)
h=ylabel('Neural response');
set(h, 'FontSize',fs)
set(gca, 'FontSize',fs);
axis([-91, 91, 0, 1.05])
set(gca, 'XTick',[-90, -45, 0, 45, 90])
set(gca, 'YTick',[0.0, 0.5, 1])
h=title('C');

set(h, 'FontSize', 20)

subplot(2,2,4)
h=plot(linspace(-90, 90, size(s2,2)), sum(ns2a, 1)/max(sum(ns2,1)), 'k');
hold on
set(h, 'LineWidth',lw);
h=plot([0, 0],[ 0, 1],'k--');
set(h, 'LineWidth',lw);

h=xlabel('Stimulus orientation');
set(h, 'FontSize',fs)

set(gca, 'FontSize',fs);
axis([-91, 91, 0, 1.05])
set(gca, 'XTick',[-90, -45, 0, 45, 90])
set(gca, 'YTick',[0.0, 0.5, 1])
h=title('D');
set(h, 'FontSize', 20)

%print(gcf, '-depsc2', 'fig2N')
