N = 360;
M = 360;
N_small = 9;
fs = 12;
orist = linspace(-90, 90, N+1);
orist = orist(1:N);
orist = orist - orist(ceil(N/2)); %blagh

pb = get_gauss_bias(360, 20, 0.15);

t_adp = get_optimal_curves(N, M, 30, pb);
t_pre = get_optimal_curves(N, M, 30, ones(1,360)/360);

t_adp_sm = get_optimal_curves(N_small, M, 30, pb);

draw_mat = @(mat) image(linspace(-90,90,N), linspace(-90, 90, N),flipdim(mat,2));

pre_prod = get_joint(t_pre, pb);
adp_prod = get_joint(t_adp, pb);

min_all = min([pre_prod(:) ; adp_prod(:)]);
max_all = max([pre_prod(:) ; adp_prod(:)] - min_all);

pre_prod_scale = 64*(pre_prod - min_all) / max_all;
adp_prod_scale = 64*(adp_prod - min_all) / max_all;

subplot(2,2,1)
h=plot(orist, pb,'k');
set(h,'LineWidth',2)
set(gca, 'XTick',[-90, -45, 0, 45, 90])
set(gca, 'YTick',[0.0, 0.005, 0.01])
axis([-90 90 0 0.01])

h=ylabel('Stimulus frequency');
set(h, 'FontSize',fs)
h=title('A');
set(h, 'FontSize',20)

subplot(2,2,3)
h=plot(orist, t_adp_sm','k');
set(h, 'LineWidth',2);
set(gca, 'XTick',[-90, -45, 0, 45, 90])
set(gca, 'YTick',[0.0, 0.5, 1])
axis([-90 90 0 1.05])
h=xlabel('Preferred orientation');
set(h, 'FontSize',fs)
h=ylabel('Neural response');
set(h, 'FontSize',fs)
h=title('C');
set(h, 'FontSize',20)

subplot(2,2,2)
draw_mat(pre_prod_scale);

h=ylabel('Preferred orientation');
set(h, 'FontSize',fs)
h=title('B');
set(h, 'FontSize',20)
set(gca, 'XTick',[-90, 0, 90])
set(gca, 'YTick',[-90, 0, 90])
axis square

subplot(2,2,4);
draw_mat(adp_prod_scale);
h=xlabel('Preferred orientation');
set(h, 'FontSize',fs)
h=ylabel('Preferred orientation');
set(h, 'FontSize',fs)
h=title('D');
set(h, 'FontSize',20)
set(gca, 'XTick',[-90, 0, 90])
set(gca, 'YTick',[-90, 0, 90])
axis square

colormap('hot')

%print(gcf, '-depsc2', 'fig2SN')
