 %first get the weights figure
clear all
sigma = get_sigma(30);

pu = ones(1,11);
pu = pu / sum(pu);

pb = ones(1,11);
pb(6) = 5;
pb = pb / sum(pb);
N = 360;
temp = 0.1;
[k_init,tb4b, tbb4b]=jnt_descend_t2(N,sigma,pu,0.0,0.01,temp,1.0);
[kb4b,tb4b, tbb4b]=jnt_descend_t2(N,sigma,pb,0.0,0.01,temp,1.0);


h=subplot(3,3,1);
p = get(h,'position');

p(1) = p(1) + 0.03;
set(h,'position',p)
norm_kern = flipdim(kb4b, 2) / mean(mean(k_init));
imagesc(linspace(-90, 90, 360), linspace(-90, 90, 360), norm_kern);
axis square;
h=colorbar;
set(h, 'YTick', 0:10)
fs = 12;
lw = 2;
set(gca, 'XTick',[-90, 0,  90])
set(gca, 'YTick',[-90, 0, 90])
set(gca, 'YTickLabel',[90, 0, -90])
set(gca,'FontSize',fs);
h=xlabel('Preferred orientation');
set(h, 'FontSize',fs);
h=ylabel('Preferred orientation');
set(h, 'FontSize',fs);
h=title('A');
set(h, 'FontSize', 20)


N = 121;
[kb4u,tb4u, tbu4b]=jnt_descend_t2(N,sigma,pu,0.0,0.01,temp,1.0);
[kb4b,tb4b, tbb4b]=jnt_descend_t2(N,sigma,pb,0.0,0.01,temp,1.0);


nrmb = max(tbb4b(:));


fs = 12;
lw = 2;
subplot(3,3,2);

h=plot(linspace(-90,90,N),tbb4b(1:10:(end-1),:)'/nrmb,'k');
set(h, 'LineWidth',lw);

hold on
h=plot(linspace(-90,90,N),tbb4b(61,:)'/nrmb,'r'); 
set(h, 'LineWidth',lw);
h=ylabel('Neural response');
set(h, 'FontSize',fs);
axis([-90,90,0.0,1.05])
set(gca, 'XTick',[-90, 0, 90])
set(gca, 'YTick',[0, 0.5, 1])
set(gca, 'FontSize',fs);
h=title('B');
set(h, 'FontSize', 20)

subplot(3,3,3)
orist = linspace(-90, 90, N+1);
orist = orist(1:N);
orist = orist - orist(ceil(N/2)); %blagh


h=plot(orist, max(tbb4b, [], 2)/max(max(tbb4b, [], 2)),'k');
set(h, 'LineWidth',lw);
h=ylabel('Response gain');
set(h, 'FontSize',fs);
axis([-90,90,0.5,1.05])
set(gca, 'XTick',[-90, 0, 90])
set(gca, 'YTick',[0.5, 0.75, 1])
set(gca, 'FontSize',fs);
h=title('C');
set(h, 'FontSize', 20)

subplot(3,3,5);
nrmu = max(tbu4b(:));
h=plot(linspace(-90,90,121),tbb4b(61,:)/nrmu,'--r');
set(h, 'LineWidth',lw);
hold on
h=plot(linspace(-90,90,121),tbu4b(61,:)/nrmu,'r');
set(h, 'LineWidth',lw);
h=plot(linspace(-90,90,121),tbu4b(69,:)/nrmu,'k');
set(h, 'LineWidth',lw);
h=plot(linspace(-90,90,121),tbb4b(69,:)/nrmu,'--k');
set(h, 'LineWidth',lw);
set(gca, 'XTick',[-90, 0, 90])
set(gca, 'YTick',[0, 0.5, 1])
set(gca, 'FontSize',fs);

h=ylabel('Neural response');
set(h, 'FontSize',fs);
h=xlabel('Stimulus orientation');
set(h, 'FontSize',fs);
axis([-90,90,0.0,1.05])
h=title('E');
set(h, 'FontSize', 20)

%


subplot(3,3,6)

h=plot(orist, get_mean(tbb4b, orist, 1),'k');
set(h, 'LineWidth',2);
h=xlabel('Preferred orientation');
set(h, 'FontSize',fs);
h=ylabel('Preferred orientation shift');
set(h, 'FontSize',fs);
axis([-90,90,-6,6])
set(gca, 'XTick',[-90, 0, 90])
set(gca, 'YTick',[-5, 0, 5])
h=xlabel('Preferred orientation');
set(h, 'FontSize',fs)
h=ylabel('Tuning curve shift');
set(h, 'FontSize',fs)
set(gca, 'FontSize',fs);
h=title('F');
set(h, 'FontSize', 20)

subplot(3,3,4)
unbiased_unadapted_mean = tb4u * pu';
biased_unadapted_mean = tb4u * pb';
biased_adapted_mean = tb4b * pb';
%scale all to the max value
%sc = max(biased_unadapted_mean);
%actually, scale all to the mean value unbiased unadapted
sc = mean(unbiased_unadapted_mean);
unbiased_unadapted_mean = unbiased_unadapted_mean / sc;
biased_adapted_mean = biased_adapted_mean / sc;
biased_unadapted_mean = biased_unadapted_mean / sc;

h=plot(linspace(-90,90,121), unbiased_unadapted_mean); %unbiased unadapted
set(h, 'Color',[0.5,0.5,0.5])
set(h, 'LineWidth',2)
hold on;
h=plot(linspace(-90,90,121), biased_unadapted_mean); %biased unadapted
set(h, 'Color',[0,0,0])
set(h, 'LineWidth',2)
h=plot(linspace(-90,90,121), biased_adapted_mean,'--'); %biased adapted
set(h, 'Color',[0,0,0])
set(h, 'LineWidth',2)

h=xlabel('Preferred orientation');
set(h, 'FontSize',fs);
h=ylabel('Mean response');
set(h, 'FontSize',fs);
%figure out y scale
ysc = ceil(max(biased_unadapted_mean));
axis([-90,90,0,ysc])
set(gca, 'XTick',[-90, 0, 90])

h=title('D');
set(h, 'FontSize', 20)

%show mean homeostasis


%print(gcf, '-depsc2', 'fig3N')
