
pu = ones(1,11);
fs = 12;
lw = 2;
sc=1.0;%subplot scaling
pu = pu / sum(pu);
temp = 0.1;
pb = ones(1,11);
pb(6) = 5;
pb = pb / sum(pb);
sigma = get_sigma(30);
N = 121;
[kb4u,tb4u, tbu4b]=jnt_descend_t2(N,sigma,pu,0.0,0.01,temp,1.0);
[kb4b,tb4b, tbb4b]=jnt_descend_t2(N,sigma,pb,0.0,0.01,temp,1.0);


breal = get_cov_real(tb4b, pb);
ubreal = get_cov_real(tb4u,pb);

weight_compare = (21/30)^2;
[w1u, w2u, tff_sm,tff_b]=weight_descend_2layer(N, sigma, pb, weight_compare, [0.005,0.005]);

%define a baseline to divide covariance matrix
[w1ub, w2ub, tff_smb,tff_ub]=weight_descend_2layer(N, sigma, pu, weight_compare, [0.005,0.005]);

[kb4b,trc_sm, trc_b]=rcov_descend_t2(N,sigma,pb,0.0,0.01,0.03,1.0);


% Now try the one-layer feedforward model
[wf1, tf1, tbf1]=one_layer_norm_model(N, sigma, pb, 0.01);
[wf1u, tf1u, tbf1u]=one_layer_norm_model(N, sigma, pu, 0.01);

one_layer_base = get_cov_real(tf1u, pu);
one_layer_cov = get_cov_real(tf1, pb);
one_layer_scale = one_layer_base(1,1);

%we need to scale covariances because different models predict different
%sized responses. divide by variance of unadapted neurons to unbiased
%ensemble

norm_base_cov = get_cov_real(tb4u, pu);
norm_cov_scale = norm_base_cov(1,1);

ff_base_cov = get_cov_real(tff_smb, pu);
ff_cov_scale = ff_base_cov(1,1);



rc_cov = get_cov_real(trc_sm, pb) / norm_cov_scale;
ff_cov = get_cov_real(tff_sm, pb) / ff_cov_scale;
prod_cov = get_cov_real(tb4b, pb) / norm_cov_scale;
one_layer_cov = one_layer_cov / one_layer_scale;
unadapt_unbiased_cov = get_cov_real(tb4u, pu) / norm_cov_scale;
unadapt_biased_cov = get_cov_real(tb4u, pb) / norm_cov_scale;

%scale them in the same way
min_all = min([rc_cov(:); ff_cov(:); prod_cov(:) ; one_layer_cov(:); unadapt_unbiased_cov(:) ; unadapt_biased_cov(:)]);
max_all = max([rc_cov(:); ff_cov(:); prod_cov(:) ; one_layer_cov(:); unadapt_unbiased_cov(:) ; unadapt_biased_cov(:)] - min_all);

rc_scaled = 64 * (rc_cov - min_all)/max_all;
ff_scaled = 64 * (ff_cov - min_all)/max_all;
prod_scaled = 64 * (prod_cov - min_all)/max_all;
one_layer_scaled = 64 * (one_layer_cov - min_all)/max_all;
uu_scaled = 64 * (unadapt_unbiased_cov - min_all)/max_all;
ub_scaled = 64 * (unadapt_biased_cov - min_all)/max_all;

draw_mat = @(mat) image(linspace(-90,90,N), linspace(-90, 90, N),flipdim(mat,2));




h=subplot(3,3,1);
draw_mat(uu_scaled)
axis square;
set(gca, 'YTick',[-90, 0, 90])
set(gca, 'XTick',[-90, 0, 90])
set(gca, 'YTickLabel',[90, 0, -90])
h=title('A');
set(h, 'FontSize', 20)
set(gca, 'FontSize',fs);

h=ylabel('Preferred orientation');
set(h, 'FontSize',fs)

h=subplot(3,3,3);
draw_mat(prod_scaled)
axis square;
set(gca, 'YTick',[-90, 0, 90])
set(gca, 'XTick',[-90, 0, 90])
set(gca, 'YTickLabel',[90, 0, -90])
h=title('C');
set(h, 'FontSize', 20)
set(gca, 'FontSize',fs);



h=subplot(3,3,2);
draw_mat(ub_scaled)
axis square;
set(gca, 'YTick',[-90, 0, 90])
set(gca, 'XTick',[-90, 0, 90])
set(gca, 'YTickLabel',[90, 0, -90])
h=title('B');
set(h, 'FontSize', 20)
set(gca, 'FontSize',fs);



h=subplot(3,3,4);
draw_mat(rc_scaled)
axis square;
set(gca, 'YTick',[-90, 0, 90])
set(gca, 'XTick',[-90, 0, 90])
set(gca, 'YTickLabel',[90, 0, -90])
h=title('D');
set(h, 'FontSize', 20)
set(gca, 'FontSize',fs);
h=xlabel('Preferred orientation');
set(h, 'FontSize',fs)
h=ylabel('Preferred orientation');
set(h, 'FontSize',fs)


h=subplot(3,3,5);
draw_mat(ff_scaled)
axis square;
set(gca, 'YTick',[-90, 0, 90])
set(gca, 'XTick',[-90, 0, 90])
set(gca, 'YTickLabel',[90, 0, -90])
h=title('E');
set(h, 'FontSize', 20)
set(gca, 'FontSize',fs);
colormap('hot')
h=xlabel('Preferred orientation');
set(h, 'FontSize',fs)


subplot(3,3,6)
draw_mat(one_layer_scaled)
axis square;
set(gca, 'YTick',[-90, 0, 90])
set(gca, 'XTick',[-90, 0, 90])
set(gca, 'YTickLabel',[90, 0, -90])
h=title('F');
set(h, 'FontSize', 20)
set(gca, 'FontSize',fs);
colormap('hot')
h=xlabel('Preferred orientation');
set(h, 'FontSize',fs);


%now draw diagonals

h=subplot(3,3,7);
p = get(h, 'Position');
p(1) = p(1) + 0.1;
p(2) = p(2) - 0.03;
p(3:4) = p(3:4) * 0.8;
set(h, 'Position', p)
%define the diagonals
diag_rc = diag(rc_scaled);
diag_ff = diag(ff_scaled);
cv = load('cov_mats');
real_cov_mat = cv.cov_mats.covA;

diag_dat = diag(cv.cov_mats.covA) - min(real_cov_mat(:));
diag_jnt = diag(prod_scaled);

diag_one = diag(one_layer_scaled);
h=plot(linspace(-90, 90, numel(diag_jnt)), diag_jnt/max(diag_jnt(:)),'Color',[71,46,170]/255);
set(h,'LineWidth',lw)

hold on

h=plot(linspace(-90, 90, numel(diag_rc)), diag_rc/max(diag_rc(:)),'Color',[36, 109, 95]/255);
set(h,'LineWidth',lw)

h=plot(linspace(-90, 90, numel(diag_one)), diag_one/max(diag_one(:)),'Color',[170,156,57]/255);
set(h,'LineWidth',lw)
h=plot(linspace(-90, 90, numel(diag_ff)), diag_ff/max(diag_ff(:)),'Color',[170,80,57]/255);
set(h,'LineWidth',lw)
h=plot(linspace(-90, 90, numel(diag_dat)), diag_dat/max(diag_dat(:)),'--k');
set(h,'LineWidth',lw)

leg=legend('response-product','covariance','one-layer gain','two-layer gain','V1 data');
p = get(leg, 'Position');
p(1) = p(1) + 0.3;
p(2)  = p(2) + 0.05;
set(leg, 'Position', p);
legend boxoff;

set(h,'LineWidth',lw)
set(gca, 'YTick',[0.5,0.75, 1.0])
set(gca, 'XTick',[-90, 0, 90])
%legend({'data','joint-product','feedforward','joint-covariance'})
h=ylabel('Normalized variance');
set(h,'FontSize',fs)
h=xlabel('Preferred orientation');
set(h,'FontSize',fs)
axis([-90, 90, 0.4, 1.1])
h=title('G');
set(h, 'FontSize', 20)

%axis square;

amt = 0.05;
for r=1:2
    for c=1:3
        ind = 3*(r-1) + c;
        h = subplot(3,3,ind);
        p = get(h, 'Position');
        p(1) = p(1) - (c-1) * amt;
        p(3:4) = p(3:4) * 0.8;
        set(h, 'Position', p);
    end
end


print(gcf, '-depsc2', 'fig4N')  
