% REAL COVARIANCE MODEL
pu = ones(1,11);

pu = pu / sum(pu);

pb = ones(1,11);
pb(6) = 5;
pb = pb / sum(pb);
sigma = get_sigma(30);
N = 121;
[kb4u,tb4u, tbu4b]=rcov_descend_t2(N,sigma,pu,0.0,0.01,0.03,1.0);
[kb4b,tb4b, tbb4b]=rcov_descend_t2(N,sigma,pb,0.0,0.01,0.03,1.0);

nrmb = max(tbb4b(:));

subplot(2,3,1);
fs = 12;


%
orist = linspace(-90, 90, N+1);
orist = orist(1:N);
orist = orist - orist(ceil(N/2)); %blagh

subplot(2,3,1)

h=plot(orist, max(tbb4b, [], 2)/max(max(tbb4b, [], 2)),'k');
set(h, 'LineWidth',2);

h=ylabel('Response gain');
set(h, 'FontSize',fs);
axis([-90,90,0.45,1.05])
set(gca, 'XTick',[-90, -45, 0, 45, 90])
set(gca, 'YTick',[0.5, 0.75, 1])
set(gca, 'FontSize',fs);
h=title('A');
set(h, 'FontSize', 20)


subplot(2,3,4)

h=plot(orist, get_mean(tbb4b, orist, 1),'k');
set(h, 'LineWidth',2);
h=xlabel('Preferred orientation');
set(h, 'FontSize',fs);
h=ylabel('Preferred orientation shift');
set(h, 'FontSize',fs);
axis([-90,90,-6,6])
set(gca, 'XTick',[-90, -45, 0, 45, 90])
set(gca, 'YTick',[-5, 0, 5])
h=xlabel('Preferred orientation');
set(h, 'FontSize',fs)
h=ylabel('Tuning curve shift');
set(h, 'FontSize',fs)
set(gca, 'FontSize',fs);
h=title('D');
set(h, 'FontSize', 20)

%FEEDFORWARD MODEL


%clear all
pu = ones(1,11);
%pu(6) = 3;
pu = pu / sum(pu);

pb = ones(1,11);
pb(6) = 5;
pb = pb / sum(pb);
sigma = 0.2;
N = 121;
adj_speeds = [0.005, 0.005];

[w1u, w2u, tb4u,tbu4b]=weight_descend_2layer(N, sigma, pu, 0.5, adj_speeds);

ratios = linspace(0.666,0.99,20);
t_adp = zeros([size(tbu4b), numel(ratios)]);
t_adp_small = zeros([size(tb4u), numel(ratios)]);
w1bs = zeros([size(w1u), numel(ratios)]);

for i = 1:numel(ratios)
    [w1b, w2b, tb4b,tbb4b]=weight_descend_2layer(N, sigma, pb, ratios(i), adj_speeds);
    t_adp(:,:,i) = tbb4b;
    w1bs(:,:,i) = w1b;
    t_adp_small(:,:,i) = tb4b;
    
end



nrmb = max(tbb4b(:));


shift_magnitudes = [];
fs=12;
if true

    for i=1:numel(ratios)
        tbb4b = t_adp(:,:,i);
        orist = linspace(-90, 90, N+1);
        orist = orist(1:N);
        orist = orist - orist(ceil(N/2)); %blagh
        tune_shifts = get_mean(tbb4b, orist, 1);
        shift_mag = max(tune_shifts);
        shift_magnitudes = [shift_magnitudes shift_mag];
    end
    
    for i =1:4:numel(ratios)
        ratios(i);
        tbb4b = t_adp(:,:,i);
        orist = linspace(-90, 90, N+1);
        orist = orist(1:N);
        orist = orist - orist(ceil(N/2)); %blagh
        
        grayval = i/numel(ratios) * [0.75,0.75,0.75];

    
    
        
        subplot(2,3,6)
        tune_shifts = get_mean(tbb4b, orist, 1);
        h=plot(orist, get_mean(tbb4b, orist, 1),'Color',grayval);
        hold on
        set(h, 'LineWidth',2);
        h=xlabel('Preferred orientation');
        set(h, 'FontSize',fs);
        %h=ylabel('Tuning curve shift')
        %set(h, 'FontSize',fs)
        axis([-90, 90 -6 6])
        set(gca,'XTick',[-90,-45,0,45,90])
        set(gca, 'FontSize',fs)
        h=title('F');
        set(gca, 'YTick',[-5, 0, 5])
        set(h, 'FontSize', 20)
        
        
        
    end
    for i=[17,1]%these are the extreme values for the ori repulsion plot
        tbb4b = t_adp(:, :, i);
        grayval = i/numel(ratios) * [0.75,0.75,0.75];

        subplot(2,3,3)
        h=plot(orist, max(tbb4b, [], 2)/max(max(tbb4b, [], 2)),'k');
        set(h, 'LineWidth',2)
        hold on
        set(h, 'Color', grayval)



        axis([-90, 90 0.45 1.1])
        set(gca,'XTick',[-90,-45,0,45,90])
        set(gca,'YTick',[0.5, 0.75, 1.0])
        set(gca, 'FontSize',fs)
        h=title('C');
        set(h, 'FontSize', 20)
    end
    
    [w1b, w2b, tb4b,tbb4b]=weight_descend_2layer(N, sigma, pb, ratios(1), adj_speeds);
    
    
    

    
    
        

end

pb = ones(1,11);
pb(6) = 5;
pb = pb / sum(pb);
sigma = 0.5;%0.025
fs = 12;

N = 121;
orist = linspace(-90, 90, N+1);
orist = orist(1:N);
orist = orist - orist(ceil(N/2)); %blagh

[w, t, tb]=one_layer_norm_model(N, sigma, pb, 0.01);
%Strawman FF model
subplot(2,3,2)
h=plot(orist, max(tb, [], 2)/max(max(tb, [], 2)),'k');
set(h, 'LineWidth',2);

axis([-90,90,0.45,1.05])
set(gca, 'XTick',[-90, -45, 0, 45, 90])
set(gca, 'YTick',[0.5, 0.75, 1])
set(gca, 'FontSize',fs);
h=title('B');
set(h, 'FontSize', 20)


subplot(2,3,5)

h=plot(orist, get_mean(tb, orist, 1),'k');
set(h, 'LineWidth',2);
h=xlabel('Preferred orientation');
set(h, 'FontSize',fs);

axis([-90,90,-6,6])
set(gca, 'XTick',[-90, -45, 0, 45, 90])
set(gca, 'YTick',[-5, 0, 5])
h=xlabel('Preferred orientation');
set(h, 'FontSize',fs)

set(gca, 'FontSize',fs);
h=title('E');
set(h, 'FontSize', 20)


%print(gcf, '-depsc2', 'fig5N')
