function imgs2 = load_imgs(dirname, k, dims)
    list = dir(dirname);
    imgs = cell(1,length(list));
    
    
    valid_entries = [];
    for entry_i=1:numel(list)
        entry = list(entry_i);
        if entry.name(1) ~= '.'
           valid_entries = [valid_entries entry_i]; 
        end
    end
    
    %shuffle them
    valid_entries = valid_entries(:, randperm(numel(valid_entries)));
    
    for entry_i = valid_entries(1:k)
        entry = list(entry_i);
        if entry.name(1) ~= '.'
            img = double(imread(fullfile(dirname,entry.name)))/(2^16-1);
            
            off_X = ceil((size(img, 2) - dims(2))*rand);
            off_Y = ceil((size(img, 1) - dims(1))*rand);
            
            img_part = sum(img(off_Y:(off_Y+dims(1)-1), off_X:(off_X+dims(2)-1), :), 3);
            
            imgs{1,entry_i} = img_part;
        end
        
    end
    lengths = cellfun(@numel, imgs);
    imgs2 = cell(1, sum(lengths ~= 0));
    
    i2=1;
    for i=1:numel(imgs)
        if ~isempty(imgs{i})
            imgs2{i2} = imgs{i};
            i2 = i2+1;
        end
    end
    
    
end