

if true
imgs = load_tx_imgs('NaturalImages',90,[256,256]);
pm2 = (avg_joint_prod(imgs, 5,8,3));
t = get_t(get_s(8,8,30), ones(8),0.5);


jp1 = t'*t;
best_m = 0;
best_m_val = inf;
for m=linspace(0,1,100)
    jp2 = m*jp1 + (1-m) * ones(8)*mean(jp1(:));
    val = mean((align_jpm(jp2,4) - align_jpm(pm2,4)).^2);
    if val < best_m_val;
        best_m = m;
        best_m_val = val;
    end
end
m = best_m;
jp2 = m*jp1 + (1-m) * ones(8)*mean(jp1(:));
hold on

orig_jpm = align_jpm(jp1, 4);
synthetic_jpm = align_jpm(jp2,4);
real_jpm = align_jpm(pm2, 4);
%mirror last point to start
orig_jpm = [orig_jpm(end), orig_jpm];
synthetic_jpm = [synthetic_jpm(end), synthetic_jpm];
real_jpm = [real_jpm(end), real_jpm];





pu = ones(1,11);

pu = pu / sum(pu);

pb = ones(1,11);
pb(6) = 5;
pb = pb / sum(pb);
sigma = 0.2^2;%0.025;
N = 121;
[kb4u,tb4u, tbu4b]=jnt_descend_mix(N,sigma,pu,m,0.03,1.0);
[kb4b,tb4b, tbb4b]=jnt_descend_mix(N,sigma,pb,m,0.03,1.0);

[kb4u_o,tb4u_o, tbu4b_o]=jnt_descend_t2(N,sigma,pu,0.0,0.01,0.03,1.0);
[kb4b_o,tb4b_o, tbb4b_o]=jnt_descend_t2(N,sigma,pb,0.0,0.01,0.03,1.0);
end

nrmb = max(tbb4b(:));


fs = 12;
lw = 2;

version1 = true;
if version1
    orist = linspace(-90, 90, N+1);
    orist = orist(1:N);
    orist = orist - orist(ceil(N/2)); %blagh


    
    %move down;
    h2 = subplot(3,3,5);
    h1 = subplot(3,3,1);
    p1 = get(h1, 'Position');
    p2 = get(h2, 'Position');
    p3 = p1;
    p3(2) = (p1(2) + p2(2))/2;
    set(h1, 'Position', p3);
    
    xs = linspace(-90,90,9);
    h=plot(xs,orig_jpm,'k');
    set(h, 'LineWidth',lw);
    hold on
    %h=plot(xs,synthetic_jpm,'Color',[0.5,0.5,0.5])
    %set(h, 'LineWidth',lw);
    hold on
    h=plot(xs,real_jpm,'Color',[0.5,0.5,0.5]);
    axis square
    set(h, 'LineWidth',lw);

    axis([-90,90,0,1]);
    h=xlabel('Relative orientation');
    set(h,'FontSize',fs);
    h=ylabel('Average response product');
    set(h,'FontSize',fs);
    set(gca,'XTick',[-90,-45,0,45,90]);
    set(gca,'YTick',[0,0.25,0.5,0.75,1.0]);
    set(gca,'FontSize',fs);
    h=title('A');
    set(h, 'FontSize', 20)
    axis square


    subplot(3,3,2)

    h=plot(orist, max(tbb4b_o, [], 2)/max(max(tbb4b_o, [], 2)),'Color',[0.5,0.5,0.5]);
    hold on
    set(h, 'LineWidth',lw);
    h=plot(orist, max(tbb4b, [], 2)/max(max(tbb4b, [], 2)),'k');

    set(h, 'LineWidth',lw);

    h=ylabel('Response gain');
    set(h, 'FontSize',fs);
    axis([-90,90,0.5,1.05])
    set(gca, 'XTick',[-90, 0, 90])
    set(gca, 'YTick',[0.5, 0.75, 1])
    set(gca, 'FontSize',fs);
    h=title('B');
    set(h, 'FontSize', 20)
    axis square

    subplot(3,3,5)

    h=plot(orist, get_mean(tbb4b_o, orist, 1),'Color',[0.5,0.5,0.5]);
    set(h, 'LineWidth',lw);
    hold on
    h=plot(orist, get_mean(tbb4b, orist, 1),'k');
    set(h, 'LineWidth',lw);
    h=xlabel('Preferred orientation');
    set(h, 'FontSize',fs);
    h=ylabel('Preferred orientation shift');
    set(h, 'FontSize',fs);
    axis([-90,90,-6,6])
    set(gca, 'XTick',[-90, 0, 90])
    set(gca, 'YTick',[-5, 0, 5])
    h=xlabel('Preferred orientation');
    set(h, 'FontSize',fs)
    h=ylabel('Tuning curve shift');
    set(h, 'FontSize',fs)
    set(gca, 'FontSize',fs);
    h=title('C');
    set(h, 'FontSize', 20)
    axis square
else
    subplot(1,2,1)
    xs = linspace(-90,90,9);
    h=plot(xs,orig_jpm,'--k');
    set(h, 'LineWidth',2);
    hold on
    h=plot(xs,synthetic_jpm,'k');
    set(h, 'LineWidth',2);
    hold on
    h=plot(xs,real_jpm,'r');
    axis square
    set(h, 'LineWidth',2);

    axis([-90,90,0,1]);
    h=xlabel('Relative orientation');
    set(h,'FontSize',fs);
    h=ylabel('Average response product');
    set(h,'FontSize',fs);
    set(gca,'XTick',[-90,0,90]);
    set(gca,'YTick',[0,0.25,0.5,0.75,1.0]);
    set(gca,'FontSize',fs);
    h=title('A');
    set(h, 'FontSize', 30)
    axis square
    
    subplot(1,2,2)
    h=plot(linspace(-90,90,N),tbb4b(1:10:(end-1),:)'/nrmb,'k');
    set(h, 'LineWidth',2);

    hold on
    h=plot(linspace(-90,90,N),tbb4b(61,:)'/nrmb,'r');
    set(h, 'LineWidth',2);
    %h=xlabel('stimulus orientation');
    %set(h, 'FontSize',fs);
    h=ylabel('Neural response');
    set(h, 'FontSize',fs);
    axis([-90,90,0.0,1.05])
    set(gca, 'XTick',[-90, -45, 0, 45, 90])
    set(gca, 'YTick',[0, 0.5, 1])
    set(gca, 'FontSize',fs);
    h=title('B');
    set(h, 'FontSize', 30)
    axis square

end

%print(gcf, '-depsc2', 'fig3SN_revise')
